﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
///using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        [DllImport("gusb.dll")]
        public static extern int OpenDevice();
        [DllImport("gusb.dll")]
        public static extern int ResetDevice();
        [DllImport("gusb.dll")]
        public static extern void CloseDevice();
        [DllImport("gusb.dll")]
        public static extern int SetUSB4AiRange( float Range);
        [DllImport("gusb.dll")]
        public static extern int SetUSB2AiRange(float Range);
        [DllImport("gusb.dll")]
        public static extern int SetSampleRate(uint SampleRate);
        [DllImport("gusb.dll")]
        public static extern int SetChanSel( UInt16 ChSel);
        [DllImport("gusb.dll")]
        public static extern int SetChanMode( byte ChanMode);
        [DllImport("gusb.dll")]
        public static extern int SetTrigSource( byte TrigSource);
        [DllImport("gusb.dll")]
        public static extern int SetSoftTrig( byte Trig);
        //public static extern int SetTrigEdge( byte TrigEdge);
        [DllImport("gusb.dll")]
        public static extern int ClearTrigger();
        //public static extern int SetDioOut( byte DioChanSel, byte DioOut);
        //public static extern int TransDioIn( byte TransDioSwitch);
        //public static extern int SetCounter( byte CtrNum, byte CtrMode, byte CtrEdge);
        //public static extern int StartCounter( byte CtrNum, byte OnOff);
        //public static extern int InitDA();
        //public static extern int SetDA( byte DANum, float DAVolt);
        //public static extern int SetWavePt( byte DANum, float DAVolt);
        //public static extern int ClrWavePt( byte DANum);
        //public static extern int SetWaveSampleRate( uint WaveSampleRate);
        //public static extern int WaveOutput( byte DANum);

        [DllImport("gusb.dll")]
        public static extern int ClearBufs();
        //public static extern int ClearCounter( byte CtrNum);
        [DllImport("gusb.dll")]
        public static extern int StartRead();
        [DllImport("gusb.dll")]
        public static extern int StopRead();
        [DllImport("gusb.dll")]
        public static extern int GetAiChans(int Num, UInt16 ChSel, float[] Ai, int TimeOut);
        public Form1()
        {
            InitializeComponent();
        }

        private void Read_Click(object sender, EventArgs e)
        {
            int temp, i;
            int QTYperCH;                                                   // 变量，一次从每个通道读取采样点数量
            uint SampleRate;                                                // 变量，采样率
            UInt16 Channel_Select = 0;                                      // 变量，通道选择
            byte ChannelMode;                                               // 变量，通道模式，0为差分，1为单端
            QTYperCH = Convert.ToInt32(QTYperCH_Input.Text);                // 将窗口输入值赋值给变量
            SampleRate = Convert.ToUInt32(SampleRate_Input.Text);           // 将窗口输入值赋值给变量
            ChannelMode = Convert.ToByte(ChannelMode_Input.Text);           // 将窗口输入值赋值给变量

            listView1.Clear();                                              // ListView初始化
            listView1.Columns.Add("Num");
            int QTYofCH = 0;                                                // 通道选择数量初始
            for (i = 0; i < 16; i++)                                        // 在循环中判断通道是否选择，如果选择在相应的通道位置置1
            {
                if (Channel_Select_Input.GetItemChecked(i))
                {
                    Channel_Select = (UInt16)(Channel_Select + (UInt16)Math.Pow(2, i));
                    listView1.Columns.Add("ai" + i.ToString());
                    QTYofCH++;                                              // 通道选择数量累加
                }
            }
            float[] ai = new float[QTYperCH * QTYofCH];         // 初始化数据存储空间数组ai,数组大小为每通道读取采样点数与通道选择数量的乘积
            
            temp = OpenDevice();                                // 打开设备
            temp = SetUSB4AiRange(10);			                // 设置量程，可带入，10，5，2，1；如果是USB2000系列，使用函数SetUSB2AiRange
            temp = SetSampleRate(SampleRate);		            // 设置采样率，如果是USB2000系列，采样率会平分到打开的所有通道。
            temp = SetChanMode(ChannelMode);                    // 通道模式设置，0为差分，1为单端
            temp = SetChanSel(Channel_Select);			        // 设置需要采集的通道

            temp = StartRead();					                // 启动读取数据线程
            //Sleep(30);							            // 等待读数线程启动完毕
            temp = SetSoftTrig( 1);				                // 设置软件触发信号

            // 用户读取数据
            // 连续采集时循环使用GetAiChans()
            temp = GetAiChans( QTYperCH, Channel_Select, ai, 4000);		                 // 超时设置4000ms

            //for (i = 0; i < QTYperCH * QTYofCH; i++)                                  //如果是电流型数据采集卡，执行该 FOR循环 的内容。
            //{
            //    ai[i] = ai[i] / 249;
            //}

            // 如果需要某个特定通道的数据，可以通过Buffer.BlockCopy实现
            float[] ai0 = new float[QTYperCH];                                           // ai0为单一通道创建的数组
            int n = 0;                                                                   // n为指定的通道，如果选择三个通道，无论是哪三个通道，从小到大的顺序都是0，1，2
            Buffer.BlockCopy(ai, QTYperCH * 4 * n, ai0, 0, QTYperCH * 4);                // 4是浮点型为4字节
            
            //以下是显示处理部分
            listView1.Items.Clear();
            for (i = 0; i < QTYperCH; i++)
            {
                ListViewItem lvi = new ListViewItem();
                lvi.Text = i.ToString();
                int j = 0, k = 0;
                for (j = 0; j < 15; j++)
                {
                    if (Channel_Select_Input.GetItemChecked(j))
                    {
                        lvi.SubItems.Add(ai[k * QTYperCH + i].ToString());
                        k++;
                    }
                }
                lvi.SubItems.Add(ai[i].ToString());
                this.listView1.Items.Add(lvi);
            }
            //以上是显示处理部分
            temp = StopRead();					// 结束读取数据线程
            temp = SetSoftTrig(0);				// 释放软件触发信号
            temp = ClearTrigger();				// 清空触发标志
            temp = ClearBufs();					// 清空所有缓存数据
            CloseDevice();                      // 关闭设备
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }
}
